src/main/java/de/nirm/zwp/entities/Developer.java
package de.nirm.zwp.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;

@Entity
public class Developer {
    @Id
    @GeneratedValue
    private Long id;

    @Column
    private String name;

    public Developer(){}



    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

}

src/main/java/de/nirm/zwp/models/DeveloperModel.java
package de.nirm.zwp.models;

public class DeveloperModel {
    private Long devId;
    private String devName;

    public DeveloperModel() {}

    @Override
    public String toString() {
        return devName;
    }

    public Long getDevId() {
        return devId;
    }

    public void setDevId(Long devId) {
        this.devId = devId;
    }

    public String getDevName() {
        return devName;
    }

    public void setDevName(String devName) {
        this.devName = devName.trim();
    }
}

src/main/java/de/nirm/zwp/HelloController.java
package de.nirm.zwp;

import javax.inject.Singleton;
import javax.ws.rs.GET;
import javax.ws.rs.Path;

/**
 *
 */
@Path("/hello")
@Singleton
public class HelloController {

    @GET
    public String sayHello() {
        return "Hello World";
    }
}

src/main/java/de/nirm/zwp/controllers/CreateBugBean.java
package de.nirm.zwp.controllers;

import de.nirm.zwp.models.BugModel;
import de.nirm.zwp.services.BugServiceBean;
import de.nirm.zwp.services.NotificationServiceBean;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.List;


@Named
@RequestScoped
public class CreateBugBean {
    @EJB
    private BugServiceBean bugServiceBean;
    @EJB
    private NotificationServiceBean notificationServiceBean;

    private BugModel newBugModel;

    @PostConstruct
    private void init(){
        newBugModel = new BugModel();
        newBugModel.setPriority("2MEDIUM");
    }

    /**
     * Submits a Bug and saves it with status open into the DB. and redirects to the startpage
     * @return return the a String with the page Name that you want to redirect to
     */
    public String submitBug(){
        newBugModel.setBugReqDate(ZonedDateTime.now(ZoneId.of("Europe/Berlin")));
        bugServiceBean.writeBug(newBugModel);
        notificationServiceBean.addGoodNotification("Your Bug '"+newBugModel.getBugName()+"' has been created!");
        return "start";
    }

    public void setBugs(List<BugModel> allbugs) {

    }

    public BugModel getNewBugModel() {
        return newBugModel;
    }

    public void setNewBugModel(BugModel newBugModel) {
        this.newBugModel = newBugModel;
    }
}

src/main/java/de/nirm/zwp/controllers/ManageDevBean.java
package de.nirm.zwp.controllers;

import de.nirm.zwp.models.DeveloperModel;
import de.nirm.zwp.services.DevServiceBean;
import de.nirm.zwp.services.NotificationServiceBean;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import java.util.List;

@Named
@RequestScoped
public class ManageDevBean {

    @EJB
    private DevServiceBean devServiceBean;

    private DeveloperModel newDevModel;

    @PostConstruct
    private void init(){
        newDevModel = new DeveloperModel();
    }

    public void submitDev(){
        devServiceBean.writeDeveloper(newDevModel);
        newDevModel.setDevName("");
    }

    public void deleteDev(Long id){
        devServiceBean.deleteDeveloper(id);
    }

    public List<DeveloperModel> getDevelopers(){
        return devServiceBean.readDevelopers();
    }

    public DeveloperModel getNewDevModel() {
        return newDevModel;
    }

    public void setNewDevModel(DeveloperModel newDevModel) {
        this.newDevModel = newDevModel;
    }
}

src/main/java/de/nirm/zwp/controllers/ShowSelectedBean.java
package de.nirm.zwp.controllers;

import de.nirm.zwp.models.BugModel;
import de.nirm.zwp.services.BugServiceBean;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;

@Named
@RequestScoped
public class ShowSelectedBean {
    @EJB
    private BugServiceBean bugServiceBean;

    private BugModel bugModel;

    private Long id;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
        bugModel = bugServiceBean.readBug(id);
    }

    public BugModel readBug(Long id){
        return bugServiceBean.readBug(id);
    }

    public BugModel getBugModel() {
        return bugModel;
    }

}

src/main/java/de/nirm/zwp/controllers/StartBean.java
package de.nirm.zwp.controllers;

import de.nirm.zwp.models.BugModel;
import de.nirm.zwp.models.DeveloperModel;
import de.nirm.zwp.services.BugServiceBean;
import de.nirm.zwp.services.NotificationServiceBean;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Named
@RequestScoped
public class StartBean {
    private final HashMap<String, String> PRIORITIES = new HashMap<String, String>(){
        {
            put("High", "1HIGH");
            put("Medium", "2MEDIUM");
            put("Low", "3LOW");
        }
    };

    @EJB
    private BugServiceBean bugServiceBean;

    public List<BugModel> getAllBugs() {
        return bugServiceBean.readBugs();
    }

    public List<BugModel> getOpenBugs() {
        return bugServiceBean.readOpenBugs();
    }

    public List<BugModel> getAssignedBugs() {
        return bugServiceBean.readAssignedBugs();
    }

    public List<BugModel> getClosedBugs() {
        return bugServiceBean.readClosedBugs();
    }

    public HashMap<String, String> getPRIORITIES() {
        return PRIORITIES;
    }

    public List<String> getPriorityLabel() {
        return new ArrayList<>(PRIORITIES.keySet());
    }

    public String getPriorityCSS(String priorityValue){
        for (Map.Entry<String, String> entry : PRIORITIES.entrySet()) {
            if (entry.getValue().equals(priorityValue)) {
                return entry.getKey();
            }
        }
        return null;
    }

    public void reserve(BugModel bugModel, DeveloperModel developerModel) {
        bugServiceBean.reserve(bugModel, developerModel);
    }

    public void updatePriority(BugModel bugModel, String prioritylabel){
        String priority = PRIORITIES.get(prioritylabel);
        bugServiceBean.updatePriority(bugModel, priority);
    }

    /**
     * When you Fixed a Bug you can close it. It will be displayed under the closed Tag
     * @param bugModel Bug Model that you want to close
     */
    public void closeBug(BugModel bugModel){
        bugModel.setBugStatus(false);
        bugModel.setFixDateToNow();
        bugServiceBean.closeBug(bugModel);
    }
    /**
     * When you can not fix a Bug you can set it to be open for everyone again.
     * @param bugModel Bug Model that you want re-open
     */
    public void reopenBug(BugModel bugModel){
        bugModel.setDeveloper(null);
        bugServiceBean.reopenBug(bugModel);
    }

}

src/main/java/de/nirm/zwp/controllers/UtilitiesBean.java
package de.nirm.zwp.controllers;

import de.nirm.zwp.services.NotificationServiceBean;

import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

@Named
@RequestScoped
public class UtilitiesBean {

    @EJB
    private NotificationServiceBean notificationServiceBean;

    /**
     * Formats a Date in a Standart Way for our Program
     * @param dateTime DateObject that you want to format
     * @return String in Form of the pattern "dd/MM/yyyy - HH:mm:ss"
     */
    public String formatDate(ZonedDateTime dateTime){
        DateTimeFormatter formatter2 = DateTimeFormatter.ofPattern("dd/MM/yyyy - HH:mm:ss");
        return dateTime.format(formatter2);
    }


    public List<String> getGoodNotifications() {
        return notificationServiceBean.getGoodNotificationList();
    }

    public List<String> getNeutralNotifications() {
        return notificationServiceBean.getNeutralNotificationList();
    }

    public List<String> getBadNotifications() {
        return notificationServiceBean.getBadNotificationList();
    }
}

src/main/java/de/nirm/zwp/services/BugServiceBean.java
package de.nirm.zwp.services;


import de.nirm.zwp.entities.Bug;
import de.nirm.zwp.entities.Developer;
import de.nirm.zwp.models.BugModel;
import de.nirm.zwp.models.DeveloperModel;
import de.nirm.zwp.repositories.BugRepository;

import javax.ejb.EJB;
import javax.ejb.Stateful;
import javax.inject.Inject;
import javax.persistence.Query;
import java.sql.BatchUpdateException;
import java.util.ArrayList;
import java.util.List;

/**
 * Mapping zwischen Entity- und Model-Bugs
 * */
@Stateful
public class BugServiceBean {

    @EJB
    BugRepository bugRepository;

    @EJB
    DevServiceBean devServiceBean;

    public BugServiceBean() {
    }


    /**
     * Bug-Entities auslesen und in Bug-Models mappen
     * @return Liste der BugModels aus der Bug-Entites
     * */
    public List<BugModel> readBugs(){

        List<BugModel> bugModels = new ArrayList<>();
        List<Bug> bugs = bugRepository.readBugs();

        bugs.forEach(bug -> {
            BugModel bugModel = mapToModel(bug);
            if (bug.getDeveloper() != null){
                bugModel.setDeveloper(devServiceBean.mapToModel(bug.getDeveloper()));
            }
            bugModels.add(bugModel);
        });

        return bugModels;
    }

    /**
     * Mapping BugEntity to Bugmodel
     * @return Bug-Model
     * */
    public BugModel mapToModel(Bug bug){

        BugModel bugModel = new BugModel();

        bugModel.setBugId(bug.getId());
        bugModel.setBugName(bug.getName());
        bugModel.setBugDescription(bug.getDescription());
        bugModel.setBugReqDate(bug.getReqDate());
        bugModel.setBugStatus(bug.getStatus());
        bugModel.setFixDate(bug.getFixDate());
        bugModel.setPriority(bug.getPriority());

        return bugModel;
    }


    /**
     * Mapping BugModel to BugEntity
     * @return Bug-Model
     * */
    public Bug mapToEntity(BugModel bugModel){

        Bug bug = new Bug();

        bug.setId(bugModel.getBugId());
        bug.setName(bugModel.getBugName());
        bug.setDescription(bugModel.getBugDescription());
        bug.setReqDate(bugModel.getBugReqDate());
        bug.setStatus(bugModel.isBugStatus());
        bug.setFixDate(bugModel.getFixDate());
        bug.setPriority(bugModel.getPriority());

        return bug;
    }

    /**
     * BugModel in BugEntity mappen
     * */
    public void writeBug(BugModel bugModel){

        System.out.println("Model  write : " + bugModel.getPriority());

        Bug bug = mapToEntity(bugModel);

        bugRepository.writeBug(bug);
    }


    /**
     * Open BugModels filtern
     * @return Liste der BugModels mit Status Open
     **/
    public List<BugModel> readOpenBugs(){
        List<BugModel> openBugs = new ArrayList<>();
        List<BugModel> bugModels = readBugs();

        bugModels.forEach(bugModel -> {
            if (bugModel.isBugStatus()==Boolean.TRUE && bugModel.getDeveloper() == null){
                openBugs.add(bugModel);
            }
        });
        return openBugs;
    }

    public List<BugModel> readAssignedBugs() {
        List<BugModel> assignedBugs = new ArrayList<>();
        List<BugModel> bugModels = readBugs();

        bugModels.forEach(bugModel -> {
            if (bugModel.isBugStatus()==Boolean.TRUE && bugModel.getDeveloper() != null){
                assignedBugs.add(bugModel);
            }
        });

        return assignedBugs;
    }


    public void reserve(BugModel bugModel, DeveloperModel developerModel){

        Developer developer = devServiceBean.mapToEntity(developerModel);

        Bug bug = bugRepository.readBug(bugModel.getBugId());
        bug.setDeveloper(developer);
        bugRepository.writeBug(bug);
    }

    public void reopenBug(BugModel bugModel) {
        Bug bugEntity = bugRepository.readBug(bugModel.getBugId());
        bugEntity.setDeveloper(null);
        bugRepository.writeBug(bugEntity);
    }

    public void closeBug(BugModel bugModel) {
        Bug bugEntity = bugRepository.readBug(bugModel.getBugId());
        bugEntity.setStatus(bugModel.isBugStatus());
        bugEntity.setFixDate(bugModel.getFixDate());
        bugRepository.writeBug(bugEntity);
    }

    /**
     * Closes BugModels filtern
     * @return Liste der BugModels mit Status Colsed
     **/
    public List<BugModel> readClosedBugs(){

        List<BugModel> closedBugs = new ArrayList<>();

        List<BugModel> bugModels = readBugs();

        bugModels.forEach(bugModel -> {
            if (bugModel.isBugStatus()==Boolean.FALSE){
                closedBugs.add(bugModel);
            }
        });

        return closedBugs;
    }

    public BugModel readBug(Long id){
        Bug bug = bugRepository.readBug(id);
        BugModel bugmodel = new BugModel();

        bugmodel.setBugName(bug.getName());
        bugmodel.setBugDescription(bug.getDescription());
        bugmodel.setPriority(bug.getPriority());
//        bugmodel.setDeveloper(bug.getDeveloper());
        bugmodel.setBugReqDate(bug.getReqDate());
//        if(bug.getFixDate() !=null){
//            bugmodel.setFixDate(bug.setFixDate());
//        }

        return bugmodel;
    }


    public void updatePriority(BugModel bugModel, String priority) {
        Bug bug = bugRepository.readBug(bugModel.getBugId());
        bug.setPriority(priority);
        bugRepository.writeBug(bug);
    }
}

src/main/java/de/nirm/zwp/services/DevServiceBean.java
package de.nirm.zwp.services;


import de.nirm.zwp.entities.Bug;
import de.nirm.zwp.entities.Developer;
import de.nirm.zwp.models.DeveloperModel;
import de.nirm.zwp.repositories.BugRepository;
import de.nirm.zwp.repositories.DevRepository;

import javax.ejb.EJB;
import javax.ejb.Stateful;
import java.util.ArrayList;
import java.util.List;


@Stateful
public class DevServiceBean {

    @EJB
    DevRepository devRepository;

    @EJB
    BugRepository bugRepository;

    @EJB
    NotificationServiceBean notificationServiceBean;


    public DevServiceBean() {
    }

    /**
     * Gets the List of Developer-Entities from DB and Maps them to Developer-Models
     * @return List of DeeloperModels
     */
    public List<DeveloperModel> readDevelopers(){

        List<DeveloperModel> devModels = new ArrayList<>();
        List<Developer> devs = devRepository.readDevelopers();

        devs.forEach(dev -> {
            // Mapping devModel <- Deveoper
            DeveloperModel devModel = mapToModel(dev);
            devModels.add(devModel);
        });
        return devModels;
    }


    /**
     * Mapping from DevEntity to DevModel
     * @param dev The Entity of the Developer
     * @return the Model of the Developer
     */
    public DeveloperModel mapToModel(Developer dev) {
        DeveloperModel devModel = new DeveloperModel();
        if (dev!=null){
            devModel.setDevId(dev.getId());
            devModel.setDevName(dev.getName());
        }
        return devModel;
    }

    /**
     * Writes a new Developer the DB. Checks if name is unique and gives Feedback to the user
     * @param devModel Developer Model to write To DB
     */
    public void writeDeveloper(DeveloperModel devModel){
        boolean unique = true;
        for(DeveloperModel dev : readDevelopers()) {
            if (dev.getDevName().trim().toLowerCase().equals(devModel.getDevName().toLowerCase()) ) {
                unique = false;
            }
        }
        if (unique){
            Developer dev = mapToEntity(devModel);
            devRepository.writeDeveloper(dev);
            notificationServiceBean.addGoodNotification("New Developer '"+devModel.getDevName()+"' has been created!");
        } else {
            notificationServiceBean.addBadNotification("There is already a Developer called " + devModel.getDevName());
        }
    }
    /**
     * Mapping from DevModel to DevEntity
     * @param devModel The odel of the Developer
     * @return the Entity of the Developer
     */
    public Developer mapToEntity(DeveloperModel devModel) {
        Developer dev = new Developer();
        // Mapping bug <- bugModel
            if (devModel != null){
                dev.setId(devModel.getDevId());
                dev.setName(devModel.getDevName());
            }

        return dev;
    }

    /**
     * Deletes a Developer from DB
     * @param id The ID of the Developer you want to delete
     */
    public void deleteDeveloper(Long id) {

        List<Bug> bugs = bugRepository.findBugOfDev(id);
        bugs.forEach(bug -> {
            bug.setDeveloper(null);
            bugRepository.writeBug(bug);
        });

        devRepository.deleteDeveloper(id);
        notificationServiceBean.addGoodNotification("A Developer has been deleted!");

    }

}

src/main/webapp/create-bug.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:p="http://xmlns.jcp.org/jsf/passthrough" xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:form="http://www.springframework.org/tags/form"
>
<ui:composition template="/template/layout.xhtml">
    <ui:define name="head">
        <title>Found Bug?</title>

        <script src="resources/tinymce/js/tinymce/tinymce.min.js" referrerpolicy="origin"></script>
        <script>tinymce.init({selector: 'textarea'});</script>

    </ui:define>
    <ui:define name="content">
        <div class="container">

            <h1 class="pageIntro">Find a Bug - Make a Ticket - Receive clean Code</h1>

            <h:form method="post" class="bugFormular">
                <h:inputText id="bugName" class="buginput" value="#{createBugBean.newBugModel.bugName}"
                             p:placeholder="Give your bug a name here"
                             required="true"
                             label="Bug needs a Name"
                />
                <h:message for="bugName" style="color:red"/>

                <h:inputTextarea id="bugDesc" class="buginput" value="#{createBugBean.newBugModel.bugDescription}"
                                 p:placeholder="Tell us more about your bug"
                                 required="true"
                                 label="Bug needs a description"/>
                <h:message for="bugDesc" style="color:red"/>
                <div class="priorityForm">
                    <h5 class="setPrioText">Choose a Priority level for your bug:</h5>
                    <h:selectOneRadio styleClass="selectpriority" value="#{createBugBean.newBugModel.priority}">

                        <f:selectItem itemValue="1HIGH" itemLabel="High" />

                        <f:selectItem itemValue="2MEDIUM" itemLabel="Medium"  />

                        <f:selectItem itemValue="3LOW" itemLabel="Low"/>

                    </h:selectOneRadio>

                </div>

                <h:commandButton id="submit" class="btn buginput" action='#{createBugBean.submitBug()}'
                                 value="Send Us The Bug"/>
            </h:form>

        </div>
    </ui:define>
</ui:composition>
</html>

src/main/webapp/manage-devs.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://java.sun.com/jsf/facelets"
>
<ui:composition template="template/layout.xhtml">
    <ui:define name="head">
        <title>Manage Developers</title>
    </ui:define>

    <ui:define name="content">
        <div class="container">
            <h1 class="pageIntro">BugFix Team</h1>
            <div>
                <h2 class="addMember">Members:</h2>
                <ui:repeat var="dev" value="#{manageDevBean.developers}">
                    <div class="row divDev" >
                        <div class="col-sm-3">
                            <img class="teamProfile" src="resources/images/managedev.png"/>
                        </div>
                        <div class="col-sm-6">
                            <p class="devName">#{dev.devName}</p>
                        </div>
                        <div class="col-sm-3 divRemove">
                            <h:form>
                                <h:commandButton class="btn remove"
                                                 action="#{manageDevBean.deleteDev(dev.devId)}"
                                                 value="Remove"/>
                            </h:form>
                        </div>
                    </div>
                </ui:repeat>
            </div>


            <div>
                <h2 class="addDev">Add Developer:</h2>
                <h:form class="row">
                    <h:inputText class="col-sm-9" id="DevName" value="#{manageDevBean.newDevModel.devName}"
                                 required="true"
                                 label="Developer needs a name"/>
                    <h:message for="DevName" style="color:red"/>

                    <h:commandButton class="btn btn-info col-sm-3" submit="submit" action='#{manageDevBean.submitDev()}'
                                     value="To Team"/>
                </h:form>
            </div>
        </div>


    </ui:define>
</ui:composition>
</html>

src/main/webapp/start.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
>
<ui:composition template="/template/layout.xhtml">
    <ui:define name="head">
        <title>BugFix</title>
    </ui:define>
    <ui:define name="content">

        <div class="container bugtickets">
            <h1 class="pageIntro">Overview</h1>
            <ul class="nav nav-tabs">
                <li class="nav-item">
                    <a class="nav-link active" data-toggle="tab" href="#Open">
                        Open
                        <h:graphicImage class="icon" value="resources/images/openbug.png"/>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" data-toggle="tab" href="#Assigned">
                        Assigned
                        <h:graphicImage class="icon" value="resources/images/assignbug.png"/>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" data-toggle="tab" href="#Closed">
                        Closed
                        <h:graphicImage class="icon" value="resources/images/closedbug.png"/>
                    </a>
                </li>
            </ul>

            <div class="tab-content">
                <div id="Open" class="tab-pane fade in active show">
                    <ui:repeat var="openBug" value="#{startBean.openBugs}">
                        <div class="row bugTicket">
                            <div class="#{startBean.getPriorityCSS(openBug.priority)} p-0">
                                <button class="btn h-100 dropdown-toggle" type="button" id="prioritySelect"
                                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                </button>
                                <div class="dropdown-menu" aria-labelledby="prioritySelect">

                                    <ui:repeat value="#{startBean.priorityLabel}" var="prioritylabel">
                                        <h:form>
                                            <h:commandButton class="dropdown-item"
                                                             action="#{startBean.updatePriority(openBug, prioritylabel)}"
                                                             value="#{prioritylabel}"/>
                                        </h:form>
                                    </ui:repeat>
                                </div>
                            </div>
                            <div class="col-md-8 col bugsreport">
                                <h2>#{openBug.bugName}</h2>
                                <div class="bugsInfo">
                                    <div class="shorterDesc">
                                        <h:outputText escape="false" value="#{openBug.bugDescription}"/>
                                    </div>
                                    <h:button class="showMore pointer" outcome="showSelectedBug" value="show more ...">
                                        <f:param name="id" value="#{openBug.bugId}"/>
                                    </h:button>
                                    <p>#{utilitiesBean.formatDate(openBug.bugReqDate)}</p>
                                </div>
                            </div>
                            <div class="col-md-3 col dropdown dev-select">
                                <button class="btn dropdown-toggle" type="button" id="dropdownMenuButton"
                                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    Set Developer
                                </button>
                                <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                    <ui:repeat value="#{manageDevBean.developers}" var="developer">
                                        <h:form>
                                            <h:commandButton class="dropdown-item"
                                                             action="#{startBean.reserve(openBug,developer)}"
                                                             value="#{developer.devName}"/>
                                        </h:form>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>
                    </ui:repeat>
                </div>

                <div id="Assigned" class="tab-pane fade">
                    <ui:repeat var="assignedBug" value="#{startBean.assignedBugs}">
                        <div class="row bugTicket">
                            <div class="#{startBean.getPriorityCSS(assignedBug.priority)}  p-0">
                                <button class="btn h-100 dropdown-toggle" type="button" id="prioritySelect"
                                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                </button>
                                <div class="dropdown-menu" aria-labelledby="prioritySelect">
                                    <ui:repeat value="#{startBean.priorityLabel}" var="prioritylabel">
                                        <h:form>
                                            <h:commandButton class="dropdown-item"
                                                             action="#{startBean.updatePriority(assignedBug, prioritylabel)}"
                                                             value="#{prioritylabel}"/>
                                        </h:form>
                                    </ui:repeat>
                                </div>
                            </div>
                            <div class="col-md-8 col bugsreport">
                                <h2>#{assignedBug.bugName}</h2>
                                <div class="bugsInfo">
                                    <div class="shorterDesc">
                                        <h:outputText escape="false" value="#{assignedBug.bugDescription}"/>
                                    </div>
                                    <h:button class="showMore pointer" outcome="showSelectedBug" value="show more ...">
                                        <f:param name="id" value="#{assignedBug.bugId}"/>
                                    </h:button>
                                    <p>Request on: #{utilitiesBean.formatDate(assignedBug.bugReqDate)}</p>
                                </div>
                            </div>
                            <div class="col-md-3 col dev-select">
                                <h3>Assigned to: #{assignedBug.developer.devName}</h3>
                                <div class="row">
                                    <div class="col">
                                        <h:form>
                                            <h:commandButton class="btn" action="#{startBean.reopenBug(assignedBug)}"
                                                             value="Re-Open"/>
                                        </h:form>
                                    </div>
                                    <div class="col">
                                        <h:form>
                                            <h:commandButton class="btn" action="#{startBean.closeBug(assignedBug)}"
                                                             value="Fixed"/>
                                        </h:form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </ui:repeat>
                </div>

                <div id="Closed" class="tab-pane fade">
                    <ui:repeat var="closedBug" value="#{startBean.closedBugs}">
                        <div class="row bugTicket">
                            <div class="col-md-8 col-10 bugsreport">
                                <h2>#{closedBug.bugName}</h2>
                                <div class="bugsInfo">
                                    <div class="shorterDesc">
                                        <h:outputText escape="false" value="#{closedBug.bugDescription}"/>
                                    </div>
                                    <h:button class="showMore" outcome="showSelectedBug" value="show more ...">
                                        <f:param name="id" value="#{closedBug.bugId}"/>
                                    </h:button>
                                </div>
                            </div>
                            <div class="col-md-4 col dev-select">
                                <p>Requested on: #{utilitiesBean.formatDate(closedBug.bugReqDate)}</p>
                                <p>Fixed on #{utilitiesBean.formatDate(closedBug.fixDate)}</p>
                            </div>
                        </div>
                    </ui:repeat>
                </div>
            </div>
        </div>
    </ui:define>
</ui:composition>
</html>